/*
 * Copyright 2013 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.db.delay;

import java.sql.SQLException;

public class DefaultDelay implements Delay {

	//
	private Object o;

	public DefaultDelay(Object a) {
		o = a;
	}

	@Override
	public Object force() {
		return o;
	}

	/* (non-Javadoc)
	 * @see net.morilib.db.misc.Delay#add(java.lang.Object[])
	 */
	@Override
	public void add(Object... args) throws SQLException {
		// do nothing
	}

	public int hashCode() {
		return o.hashCode();
	}

	public boolean equals(Object o) {
		return o != null && this.o.equals(o);
	}

}
