package net.morilib.db.jdbc;

import java.io.IOException;
import java.sql.Connection;
import java.sql.Driver;
import java.sql.DriverPropertyInfo;
import java.sql.SQLException;
import java.util.Properties;

import net.morilib.db.engine.SqlEngineFactory;
import net.morilib.db.schema.SqlSchemaFactory;

public class RelationsDriver implements Driver {

	private static final String URI_PREFIX = "jdbc:relations:";

	static {
		try {
			java.sql.DriverManager.registerDriver(new RelationsDriver());
		} catch (SQLException e) {
			throw new RuntimeException("Can't regist driver");
		}
	}

	@Override
	public boolean acceptsURL(String url) throws SQLException {
		return false;
	}

	@Override
	public Connection connect(String url,
			Properties info) throws SQLException {
		try {
			if(url.startsWith(URI_PREFIX)) {
				return new RelationsConnection(url,
						SqlEngineFactory.getInstance().getEngine(),
						SqlSchemaFactory.getInstance().getByURL(url));
			}
			return null;
		} catch (IOException e) {
			return null;
		}
	}

	@Override
	public int getMajorVersion() {
		return 0;
	}

	@Override
	public int getMinorVersion() {
		return 0;
	}

	@Override
	public DriverPropertyInfo[] getPropertyInfo(String url,
			Properties info) throws SQLException {
		return new DriverPropertyInfo[0];
	}

	@Override
	public boolean jdbcCompliant() {
		return false;
	}

}
