/*
 * Copyright 2013 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.db.sqlcs.ddl;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class SqlAlterTableDrop {

	//
	private String name;
	private List<String> colnames;

	public SqlAlterTableDrop(String n, List<String> d) {
		name = n;
		colnames = new ArrayList<String>(d);
	}

	public String getName() {
		return name;
	}

	public List<String> getColumnNames() {
		return Collections.unmodifiableList(colnames);
	}

	public String toString() {
		StringBuffer b = new StringBuffer("ALTER TABLE ");
		String d = "\n  ";

		b.append(name).append(" DROP (");
		for(String x : colnames) {
			b.append(d).append(x);
			d = ",\n  ";
		}
		return b.append('\n').append(')').toString();
	}

}
