/*
 * Copyright 2013 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.db.sqlcs.dml;

import net.morilib.db.misc.Rational;

public class SqlNumeric implements SqlLiteral {

	private Rational value;

	public SqlNumeric(Rational v) {
		value = v;
	}

	public Rational getValue() {
		return value;
	}

	@Override
	public int getMaxParameter() {
		return 0;
	}

	public String toString() {
		return value.toString();
	}

}
