/*
 * Copyright 2009-2010 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.db.sqlcs.dml;

import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.Map;

/**
 *
 *
 * @author MORIGUCHI, Yuichiro 2013/08/17
 */
public class SqlWith {

	private Map<String, SqlSetExpression> map;

	public SqlWith(Map<String, SqlSetExpression> m) {
		map = new LinkedHashMap<String, SqlSetExpression>(m);
	}

	/**
	 * 
	 * @return
	 */
	public Map<String, SqlSetExpression> getWith() {
		return Collections.unmodifiableMap(map);
	}

}
